<?php
/**
 * Clase Base DP para BaseCrCreditoPagoDP
 *
 * @package    
 * @subpackage BaseCrCreditoPagoDP
 * @author     Willy
 * @version    SVN:: BaseCrCreditoPagoDP.class.php,v 1.1 2013-01-04 11:11:45 william.taype Exp $
 */
abstract class BaseCrCreditoPagoDP extends CrCreditoPagoBN
{
  /* N�mero de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrCreditoPagoBN )
    {
      $o_CrCreditoPagoBN = $bSetDefault;
      if($o_CrCreditoPagoBN->getIdpago()) : $this->setIdpago($o_CrCreditoPagoBN->getIdpago()); endif;
      if($o_CrCreditoPagoBN->getTipopago()) : $this->setTipopago($o_CrCreditoPagoBN->getTipopago()); endif;
      if($o_CrCreditoPagoBN->getFechatrx()) : $this->setFechatrx($o_CrCreditoPagoBN->getFechatrx()); endif;
      if($o_CrCreditoPagoBN->getMontopago()) : $this->setMontopago($o_CrCreditoPagoBN->getMontopago()); endif;
      if($o_CrCreditoPagoBN->getFechacreacion()) : $this->setFechacreacion($o_CrCreditoPagoBN->getFechacreacion()); endif;
      if($o_CrCreditoPagoBN->getUsauriocreacion()) : $this->setUsauriocreacion($o_CrCreditoPagoBN->getUsauriocreacion()); endif;
      if($o_CrCreditoPagoBN->getEliminado()) : $this->setEliminado($o_CrCreditoPagoBN->getEliminado()); endif;
      if($o_CrCreditoPagoBN->getFechaeliminado()) : $this->setFechaeliminado($o_CrCreditoPagoBN->getFechaeliminado()); endif;
      if($o_CrCreditoPagoBN->getUsuarioeliminado()) : $this->setUsuarioeliminado($o_CrCreditoPagoBN->getUsuarioeliminado()); endif;
      if($o_CrCreditoPagoBN->getNumerorecibo()) : $this->setNumerorecibo($o_CrCreditoPagoBN->getNumerorecibo()); endif;
      if($o_CrCreditoPagoBN->getBanco()) : $this->setBanco($o_CrCreditoPagoBN->getBanco()); endif;
      if($o_CrCreditoPagoBN->getNumerooperacion()) : $this->setNumerooperacion($o_CrCreditoPagoBN->getNumerooperacion()); endif;
      if($o_CrCreditoPagoBN->getFechaoperacion()) : $this->setFechaoperacion($o_CrCreditoPagoBN->getFechaoperacion()); endif;
      if($o_CrCreditoPagoBN->getObservacion()) : $this->setObservacion($o_CrCreditoPagoBN->getObservacion()); endif;
      if($o_CrCreditoPagoBN->getIdcuota()) : $this->setIdcuota($o_CrCreditoPagoBN->getIdcuota()); endif;
      if($o_CrCreditoPagoBN->getIdcreditocrono()) : $this->setIdcreditocrono($o_CrCreditoPagoBN->getIdcreditocrono()); endif;
      if($o_CrCreditoPagoBN->getIdcolaborador()) : $this->setIdcolaborador($o_CrCreditoPagoBN->getIdcolaborador()); endif;
    }
  }

  /* Obtiene el n�mero de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(idpago),(MAX(idpago)+1), 1) AS Maximo FROM cr_credito_pago;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdpago($row[0]);

      if($this->getIdpago()){
        $a_Fields = array();

        if($this->getIdpago()) : $a_Fields['idpago'] = ($this->getIdpago()); endif;
        if($this->getTipopago()) : $a_Fields['tipopago'] = ($this->getTipopago()); endif;
        if($this->getFechatrx()) : $a_Fields['fechatrx'] = ($this->getFechatrx()); endif;
        if($this->getMontopago()) : $a_Fields['montopago'] = ($this->getMontopago()); endif;
        if($this->getFechacreacion()) : $a_Fields['fechacreacion'] = ($this->getFechacreacion()); endif;
        if($this->getUsauriocreacion()) : $a_Fields['usuariocreacion'] = ($this->getUsauriocreacion()); endif;
        if($this->getEliminado()) : $a_Fields['eliminado'] = ($this->getEliminado()); endif;
        if($this->getFechaeliminado()) : $a_Fields['fechaeliminado'] = ($this->getFechaeliminado()); endif;
        if($this->getUsuarioeliminado()) : $a_Fields['usuarioeliminado'] = ($this->getUsuarioeliminado()); endif;
        if($this->getNumerorecibo()) : $a_Fields['numerorecibo'] = ($this->getNumerorecibo()); endif;
        if($this->getBanco()) : $a_Fields['banco'] = ($this->getBanco()); endif;
        if($this->getNumerooperacion()) : $a_Fields['numerooperacion'] = ($this->getNumerooperacion()); endif;
        if($this->getFechaoperacion()) : $a_Fields['fechaoperacion'] = ($this->getFechaoperacion()); endif;
        if($this->getObservacion()) : $a_Fields['observacion'] = ($this->getObservacion()); endif;
        if($this->getIdcuota()) : $a_Fields['idcuota'] = ($this->getIdcuota()); endif;
        if($this->getIdcreditocrono()) : $a_Fields['idcreditocrono'] = ($this->getIdcreditocrono()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_credito_pago (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdpago())
      {
        $a_Fields = array();

        if($this->getIdpago()) : $a_Fields['idpago'] = ($this->getIdpago()); endif;
        if($this->getTipopago()) : $a_Fields['tipopago'] = ($this->getTipopago()); endif;
        if($this->getFechatrx()) : $a_Fields['fechatrx'] = ($this->getFechatrx()); endif;
        if($this->getMontopago()) : $a_Fields['montopago'] = ($this->getMontopago()); endif;
        if($this->getFechacreacion()) : $a_Fields['fechacreacion'] = ($this->getFechacreacion()); endif;
        if($this->getUsauriocreacion()) : $a_Fields['usuariocreacion'] = ($this->getUsauriocreacion()); endif;
        if($this->getEliminado()) : $a_Fields['eliminado'] = ($this->getEliminado()); endif;
        if($this->getFechaeliminado()) : $a_Fields['fechaeliminado'] = ($this->getFechaeliminado()); endif;
        if($this->getUsuarioeliminado()) : $a_Fields['usuarioeliminado'] = ($this->getUsuarioeliminado()); endif;
        if($this->getNumerorecibo()) : $a_Fields['numerorecibo'] = ($this->getNumerorecibo()); endif;
        if($this->getBanco()) : $a_Fields['banco'] = ($this->getBanco()); endif;
        if($this->getNumerooperacion()) : $a_Fields['numerooperacion'] = ($this->getNumerooperacion()); endif;
        if($this->getFechaoperacion()) : $a_Fields['fechaoperacion'] = ($this->getFechaoperacion()); endif;
        if($this->getObservacion()) : $a_Fields['observacion'] = ($this->getObservacion()); endif;
        if($this->getIdcuota()) : $a_Fields['idcuota'] = ($this->getIdcuota()); endif;
        if($this->getIdcreditocrono()) : $a_Fields['idcreditocrono'] = ($this->getIdcreditocrono()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_credito_pago SET ".$sStringField." WHERE 1 AND idpago='".$this->getIdpago()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdpago())
      {
        $a_Fields = array();
		if($this->getIdpago()) $where =  " and idpago = '".$this->getIdpago()."'";
        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_credito_pago WHERE 1 AND idpago='".$this->getIdpago()."' $where;"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* B�squeda del registro por la llave primaria */
  public static function selectByPK($vIdpago)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idpago, tipopago, fechatrx, montopago, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, numerorecibo, banco, numerooperacion, fechaoperacion, observacion, idcuota, idcreditocrono, idcolaborador FROM cr_credito_pago WHERE 1 AND idpago='".$vIdpago."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrCreditoPagoDP = new CrCreditoPagoDP();
    $o_CrCreditoPagoDP->setIdpago($o_propel->idpago);
    $o_CrCreditoPagoDP->setTipopago($o_propel->tipopago);
    $o_CrCreditoPagoDP->setFechatrx($o_propel->fechatrx);
    $o_CrCreditoPagoDP->setMontopago($o_propel->montopago);
    $o_CrCreditoPagoDP->setFechacreacion($o_propel->fechacreacion);
    $o_CrCreditoPagoDP->setUsauriocreacion($o_propel->usuariocreacion);
    $o_CrCreditoPagoDP->setEliminado($o_propel->eliminado);
    $o_CrCreditoPagoDP->setFechaeliminado($o_propel->fechaeliminado);
    $o_CrCreditoPagoDP->setUsuarioeliminado($o_propel->usuarioeliminado);
    $o_CrCreditoPagoDP->setNumerorecibo($o_propel->numerorecibo);
    $o_CrCreditoPagoDP->setBanco($o_propel->banco);
    $o_CrCreditoPagoDP->setNumerooperacion($o_propel->numerooperacion);
    $o_CrCreditoPagoDP->setFechaoperacion($o_propel->fechaoperacion);
    $o_CrCreditoPagoDP->setObservacion($o_propel->observacion);
    $o_CrCreditoPagoDP->setIdcuota($o_propel->idcuota);
    $o_CrCreditoPagoDP->setIdcreditocrono($o_propel->idcreditocrono);
    $o_CrCreditoPagoDP->setIdcolaborador($o_propel->idcolaborador);
    return $o_CrCreditoPagoDP;
  }
}